DOTTRACKER_VERSION = 2.12;

DOTTRACKER_MIN_WIDTH = 50;
DOTTRACKER_MIN_HEIGHT = 50;

DOTTRACKER_NO_FRAME_WIDTH = 30;
DOTTRACKER_NO_FRAME_HEIGHT = 30;

DOTTRACKER_MAX_DEATH_KNIGHT = 2;
DOTTRACKER_MAX_DRUID = 7;
DOTTRACKER_MAX_HUNTER = 1;
DOTTRACKER_MAX_MAGE = 1;
DOTTRACKER_MAX_PALADIN = 1;
DOTTRACKER_MAX_PRIEST = 3;
DOTTRACKER_MAX_SHAMAN = 1;
DOTTRACKER_MAX_WARLOCK = 7;
DOTTRACKER_MAX_WARRIOR = 5;

DotTracker_Options = {
	version,
    show = true,
    lock = false,
    tooltip = true,
    alpha = 1,
	help = false,

	widthType = 1,
	text = true,
	minWidth = 50,
	reminderFadeUp = false,
	showInVehicle = false,
	stanceCheck = false,
	showFrames = true,
	reminderAlpha = 1
};

DotTracker_Setting = {
	showDotA = true,
	showDotB = true,
	showDotC = true,
	showDotD = true,
	showDotE = true,
	showDotF = true,
	showDotG = true,

	combatOnly = true,

	reminderDotA = 0,
	reminderDotB = 0, 
	reminderDotC = 0,
	reminderDotD = 0,
	reminderDotE = 0,
	reminderDotF = 0,
	reminderDotG = 0,

	minLevelDotA = 0,
	minLevelDotB = 0,
	minLevelDotC = 0,
	minLevelDotD = 0,
	minLevelDotE = 0,
	minLevelDotF = 0,
	minLevelDotG = 0,

	widthA = 50,
	widthB = 50,
	widthC = 50,
	widthD = 50,
	widthE = 50,
	widthF = 50,
	widthG = 50,

	showTextA = true,
	showTextB = true,
	showTextC = true,
	showTextD = true,
	showTextE = true,
	showTextF = true,
	showTextG = true
};

DotTracker_Dots = {
	last_curse_icon = "Interface\\Icons\\Spell_shadow_curseoftounges",
	last_bane_icon = "Interface\\Icons\\Spell_shadow_curseofsargeras",
	last_immolate_icon = "Interface\\Icons\\Spell_fire_immolation",
	last_immolate_text = DotTracker_WARLOCK_DotB,
	class,
	textA,
	textB,
	textC,
	textD,
	textE,
	textF,
	textG,

	remTextA,
	remTextB,
	remTextC,
	remTextD,
	remTextE,
	remTextF,
	remTextG,

	lvlTextA,
	lvlTextB,
	lvlTextC,
	lvlTextD,
	lvlTextE,
	lvlTextF,
	lvlTextG,

	stance,
	spec,

	current_min_width = DOTTRACKER_MIN_WIDTH,
	current_min_height = DOTTRACKER_MIN_HEIGHT,

	setupUI = false
};

DotTracker_test = 100;

DotTracker_SpecA = {
	widthType = 1,
	text = true,
	minWidth = 50,
	reminderFadeUp = false,
	showInVehicle = false,
	showDotA = true,
	showDotB = true,
	showDotC = true,
	showDotD = true,
	showDotE = true,
	showDotF = true,
	showDotG = true,

	combatOnly = true,
	reminderDotA = 0,
	reminderDotB = 0, 
	reminderDotC = 0,
	reminderDotD = 0,
	reminderDotE = 0,
	reminderDotF = 0,
	reminderDotG = 0,

	minLevelDotA = 0,
	minLevelDotB = 0,
	minLevelDotC = 0,
	minLevelDotD = 0,
	minLevelDotE = 0,
	minLevelDotF = 0,
	minLevelDotG = 0,

	stanceCheck = true,
	showFrames = true,

	widthA = 50,
	widthB = 50,
	widthC = 50,
	widthD = 50,
	widthE = 50,
	widthF = 50,
	widthG = 50,

	reminderAlpha = 1,

	showTextA = true,
	showTextB = true,
	showTextC = true,
	showTextD = true,
	showTextE = true,
	showTextF = true,
	showTextG = true
};

DotTracker_SpecB = {
	widthType = 1,
	text = true,
	minWidth = 50,
	reminderFadeUp = false,
	showInVehicle = false,
	showDotA = true,
	showDotB = true,
	showDotC = true,
	showDotD = true,
	showDotE = true,
	showDotF = true,
	showDotG = true,

	combatOnly = true,
	reminderDotA = 0,
	reminderDotB = 0, 
	reminderDotC = 0,
	reminderDotD = 0,
	reminderDotE = 0,
	reminderDotF = 0,
	reminderDotG = 0,

	minLevelDotA = 0,
	minLevelDotB = 0,
	minLevelDotC = 0,
	minLevelDotD = 0,
	minLevelDotE = 0,
	minLevelDotF = 0,
	minLevelDotG = 0,

	stanceCheck = true,
	showFrames = true,

	widthA = 50,
	widthB = 50,
	widthC = 50,
	widthD = 50,
	widthE = 50,
	widthF = 50,
	widthG = 50,

	reminderAlpha = 1,

	showTextA = true,
	showTextB = true,
	showTextC = true,
	showTextD = true,
	showTextE = true,
	showTextF = true,
	showTextG = true
};