function DotTracker_ClassShow()
	if ( DotTracker_Dots.class == "DEATHKNIGHT" ) then
		DotTracker_ClassShowText(DOTTRACKER_MAX_DEATH_KNIGHT);
	elseif ( DotTracker_Dots.class == "DRUID" ) then
		DotTracker_ClassShowText(DOTTRACKER_MAX_DRUID);
	elseif ( DotTracker_Dots.class == "HUNTER" ) then
		DotTracker_ClassShowText(DOTTRACKER_MAX_HUNTER);
	elseif ( DotTracker_Dots.class == "MAGE" ) then
		DotTracker_ClassShowText(DOTTRACKER_MAX_MAGE);
	elseif ( DotTracker_Dots.class == "PALADIN" ) then
		DotTracker_ClassShowText(DOTTRACKER_MAX_PALADIN);
	elseif ( DotTracker_Dots.class == "PRIEST" ) then
		DotTracker_ClassShowText(DOTTRACKER_MAX_PRIEST);
	elseif ( DotTracker_Dots.class == "SHAMAN" ) then
		DotTracker_ClassShowText(DOTTRACKER_MAX_SHAMAN);
	elseif ( DotTracker_Dots.class == "WARLOCK" ) then
		DotTracker_ClassShowText(DOTTRACKER_MAX_WARLOCK);
	elseif ( DotTracker_Dots.class == "WARRIOR" ) then
		DotTracker_ClassShowText(DOTTRACKER_MAX_WARRIOR);
	end
end


function DotTracker_ClassCheck()
	if ( DotTracker_Dots.class == "DEATHKNIGHT" ) then
		DotTracker_DeathKnightCheck();
	elseif ( DotTracker_Dots.class == "DRUID" ) then
		DotTracker_DruidCheck();
	elseif ( DotTracker_Dots.class == "HUNTER" ) then
		DotTracker_HunterCheck();
	elseif ( DotTracker_Dots.class == "MAGE" ) then
		DotTracker_MageCheck();
	elseif ( DotTracker_Dots.class == "PALADIN" ) then
		DotTracker_PaladinCheck();
	elseif ( DotTracker_Dots.class == "PRIEST" ) then
		DotTracker_PriestCheck();
	elseif ( DotTracker_Dots.class == "SHAMAN" ) then
		DotTracker_ShamanCheck();
	elseif ( DotTracker_Dots.class == "WARLOCK" ) then
		DotTracker_WarlockCheck();
	elseif ( DotTracker_Dots.class == "WARRIOR" ) then
		DotTracker_WarriorCheck();
	end
end


function DotTracker_Show_All_DoTs()
	local max;
	if ( DotTracker_Dots.class == "DEATHKNIGHT" ) then
		max = DOTTRACKER_MAX_DEATH_KNIGHT;
	elseif ( DotTracker_Dots.class == "DRUID" ) then
		max = DOTTRACKER_MAX_DRUID;
	elseif ( DotTracker_Dots.class == "HUNTER" ) then
		max = DOTTRACKER_MAX_HUNTER;
	elseif ( DotTracker_Dots.class == "MAGE" ) then
		max = DOTTRACKER_MAX_MAGE;
	elseif ( DotTracker_Dots.class == "PALADIN" ) then
		max = DOTTRACKER_MAX_PALADIN;
	elseif ( DotTracker_Dots.class == "PRIEST" ) then
		max = DOTTRACKER_MAX_PRIEST;
	elseif ( DotTracker_Dots.class == "SHAMAN" ) then
		max = DOTTRACKER_MAX_SHAMAN;
	elseif ( DotTracker_Dots.class == "WARLOCK" ) then
		max = DOTTRACKER_MAX_WARLOCK;
	elseif ( DotTracker_Dots.class == "WARRIOR" ) then
		max = DOTTRACKER_MAX_WARRIOR;
	end

	if ( max >= 1 ) then
		DotTracker_ShowFrame(DotTracker_Setting.showDotA, DotTracker_Setting.showTextA, DotTracker_Dots.textA, 1, DotTracker_DotA_Frame, DotTracker_DotA_Frame_Text);
	end
	if ( max >= 2 ) then
		DotTracker_ShowFrame(DotTracker_Setting.showDotB, DotTracker_Setting.showTextB, DotTracker_Dots.textB, 1, DotTracker_DotB_Frame, DotTracker_DotB_Frame_Text);
	end
	if ( max >= 3 ) then
		DotTracker_ShowFrame(DotTracker_Setting.showDotC, DotTracker_Setting.showTextC, DotTracker_Dots.textC, 1, DotTracker_DotC_Frame, DotTracker_DotC_Frame_Text);
	end
	if ( max >= 4 ) then
		DotTracker_ShowFrame(DotTracker_Setting.showDotD, DotTracker_Setting.showTextD, DotTracker_Dots.textD, 1, DotTracker_DotD_Frame, DotTracker_DotD_Frame_Text);
	end
	if ( max >= 5 ) then
		DotTracker_ShowFrame(DotTracker_Setting.showDotE, DotTracker_Setting.showTextE, DotTracker_Dots.textE, 1, DotTracker_DotE_Frame, DotTracker_DotE_Frame_Text);
	end
	if ( max >= 6 ) then
		DotTracker_ShowFrame(DotTracker_Setting.showDotF, DotTracker_Setting.showTextF, DotTracker_Dots.textF, 1, DotTracker_DotF_Frame, DotTracker_DotF_Frame_Text);
	end
	if ( max >= 7 ) then
		DotTracker_ShowFrame(DotTracker_Setting.showDotG, DotTracker_Setting.showTextG, DotTracker_Dots.textG, 1, DotTracker_DotG_Frame, DotTracker_DotG_Frame_Text);
	end
end


function DotTracker_InitReminders()
	local iconA = "Interface\\Icons\\Spell_deathknight_frostfever";
	local iconB = "Interface\\Icons\\Spell_deathknight_frostfever";
	local iconC = "Interface\\Icons\\Spell_deathknight_frostfever";
	local iconD = "Interface\\Icons\\Spell_deathknight_frostfever";
	local iconE = "Interface\\Icons\\Spell_deathknight_frostfever";
	local iconF = "Interface\\Icons\\Spell_deathknight_frostfever";
	local iconG = "Interface\\Icons\\Spell_deathknight_frostfever";

	DotTracker_Dots.textA = " ";
	DotTracker_Dots.textB = " ";
	DotTracker_Dots.textC = " ";
	DotTracker_Dots.textD = " ";
	DotTracker_Dots.textE = " ";
	DotTracker_Dots.textF = " ";
	DotTracker_Dots.textG = " ";

	if ( DotTracker_Dots.class == "DEATHKNIGHT" ) then
		DotTracker_Dots.textA = DotTracker_DEATHKNIGHT_DotA;
		iconA = "Interface\\Icons\\Spell_deathknight_frostfever";
		DotTracker_Dots.textB = DotTracker_DEATHKNIGHT_DotB;
		iconB = "Interface\\Icons\\Spell_deathknight_bloodplague";
		
	elseif ( DotTracker_Dots.class == "DRUID" ) then
		DotTracker_Dots.textA = DotTracker_DRUID_DotA;
		iconA = "Interface\\Icons\\Spell_nature_starfall";
		DotTracker_Dots.textB = DotTracker_DRUID_DotB;
		iconB = "Interface\\Icons\\Spell_nature_faeriefire";
		DotTracker_Dots.textC = DotTracker_DRUID_DotC;
		iconC = "Interface\\Icons\\Spell_nature_insectswarm";
		DotTracker_Dots.textC = DotTracker_DRUID_DotD;
		iconD = "Interface\\Icons\\ability_druid_infectedwound";
		DotTracker_Dots.textC = DotTracker_DRUID_DotE;
		iconE = "Interface\\Icons\\ability_druid_mangle2";
		DotTracker_Dots.textC = DotTracker_DRUID_DotF;
		iconF = "Interface\\Icons\\ability_druid_disembowel";
		DotTracker_Dots.textC = DotTracker_DRUID_DotG;
		iconG = "Interface\\Icons\\ability_ghoulfrenzy";
	
	elseif ( DotTracker_Dots.class == "HUNTER" ) then
		DotTracker_Dots.textA = DotTracker_HUNTER_DotA;
		iconA = "Interface\\Icons\\Spell_nature_insectswarm";
	
	elseif ( DotTracker_Dots.class == "MAGE" ) then
		DotTracker_Dots.textA = DotTracker_MAGE_DotA;
		iconA = "Interface\\Icons\\ability_mage_livingbomb";

	elseif ( DotTracker_Dots.class == "PALADIN" ) then
		DotTracker_Dots.textA = DotTracker_PALADIN_DotA;
		iconA = DotTracker_Dots.last_curse_icon;
	
	elseif ( DotTracker_Dots.class == "PRIEST" ) then
		DotTracker_Dots.textA = DotTracker_PRIEST_DotA;
		iconA = "Interface\\Icons\\Spell_shadow_devouringplague";
		DotTracker_Dots.textB = DotTracker_PRIEST_DotB;
		iconB = "Interface\\Icons\\Spell_holy_stoicism";
		DotTracker_Dots.textC = DotTracker_PRIEST_DotC;
		iconC = "Interface\\Icons\\Spell_shadow_shadowwordpain";

	elseif ( DotTracker_Dots.class == "SHAMAN" ) then
		DotTracker_Dots.textA = DotTracker_SHAMAN_DotA;
		iconA = "Interface\\Icons\\Spell_fire_flameshock";

	elseif ( DotTracker_Dots.class == "WARLOCK" ) then
		DotTracker_Dots.textA = DotTracker_WARLOCK_DotA;
		iconA = "Interface\\Icons\\Spell_shadow_abominationexplosion";
		DotTracker_Dots.textB = DotTracker_WARLOCK_DotB;
		iconB = DotTracker_Dots.last_immolate_icon;
		DotTracker_Dots.textC = DotTracker_WARLOCK_DotC;
		iconC = DotTracker_Dots.last_curse_icon;
		DotTracker_Dots.textD = DotTracker_WARLOCK_DotD;
		iconD = "Interface\\Icons\\Spell_shadow_shadowbolt";
		DotTracker_Dots.textE = DotTracker_WARLOCK_DotE;
		iconE = DotTracker_Dots.last_bane_icon;
		DotTracker_Dots.textF = DotTracker_WARLOCK_DotF;
		iconF = "Interface\\Icons\\Ability_warlock_haunt";
		DotTracker_Dots.textG = DotTracker_WARLOCK_DotG;
		iconG = "Interface\\Icons\\Spell_shadow_shadowbolt";
		
	elseif ( DotTracker_Dots.class == "WARRIOR" ) then
		DotTracker_Dots.textA = DotTracker_WARRIOR_DotA;
		iconA = "Interface\\Icons\\Ability_gouge";
		DotTracker_Dots.textB = DotTracker_WARRIOR_DotB;
		iconB = "Interface\\Icons\\Ability_warrior_sunder";
		DotTracker_Dots.textC = DotTracker_WARRIOR_DotC;
		iconC = "Interface\\Icons\\Ability_shockwave";
		DotTracker_Dots.textD = DotTracker_WARRIOR_DotD;
		iconD = "Interface\\Icons\\spell_nature_thunderclap";
		DotTracker_Dots.textE = DotTracker_WARRIOR_DotE;
		iconE = "Interface\\Icons\\ability_warrior_warcry";
		
	end

	DotTracker_DotA_Frame_Text:SetText(DotTracker_Dots.textA);
	DotTracker_DotA_Frame_Icon:SetTexture(iconA);			
	DotTracker_DotB_Frame_Text:SetText(DotTracker_Dots.textB);
	DotTracker_DotB_Frame_Icon:SetTexture(iconB);			
	DotTracker_DotC_Frame_Text:SetText(DotTracker_Dots.textC);
	DotTracker_DotC_Frame_Icon:SetTexture(iconC);			
	DotTracker_DotD_Frame_Text:SetText(DotTracker_Dots.textD);
	DotTracker_DotD_Frame_Icon:SetTexture(iconD);			
	DotTracker_DotE_Frame_Text:SetText(DotTracker_Dots.textE);
	DotTracker_DotE_Frame_Icon:SetTexture(iconE);			
	DotTracker_DotF_Frame_Text:SetText(DotTracker_Dots.textF);
	DotTracker_DotF_Frame_Icon:SetTexture(iconF);			
	DotTracker_DotG_Frame_Text:SetText(DotTracker_Dots.textG);
	DotTracker_DotG_Frame_Icon:SetTexture(iconG);			
end


function DotTracker_Setting_ClassRef(dot)
	local text;

	if ( DotTracker_Dots.class == "DEATHKNIGHT" ) then
		if ( dot == 1 ) then
			return DotTracker_DEATHKNIGHT_DotA;
		elseif ( dot == 2 ) then
			return DotTracker_DEATHKNIGHT_DotB;
		end

	elseif ( DotTracker_Dots.class == "DRUID" ) then
		if ( dot == 1 ) then
			return DotTracker_DRUID_DotA;
		elseif ( dot == 2 ) then
			return DotTracker_DRUID_DotB;
		elseif ( dot == 3 ) then
			return DotTracker_DRUID_DotC;
		elseif ( dot == 4 ) then
			return DotTracker_DRUID_DotD;
		elseif ( dot == 5 ) then
			return DotTracker_DRUID_DotE;
		elseif ( dot == 6 ) then
			return DotTracker_DRUID_DotF;
		elseif ( dot == 7 ) then
			return DotTracker_DRUID_DotG;
		end

	elseif ( DotTracker_Dots.class == "HUNTER" ) then
		if ( dot == 1 ) then
			return DotTracker_HUNTER_DotA;
		end

	elseif ( DotTracker_Dots.class == "MAGE" ) then
		if ( dot == 1 ) then
			return DotTracker_MAGE_DotA;
		end

	elseif ( DotTracker_Dots.class == "PALADIN" ) then
		if ( dot == 1 ) then
			return DotTracker_PALADIN_DotA;
		end

	elseif ( DotTracker_Dots.class == "PRIEST" ) then
		if ( dot == 1 ) then
			return DotTracker_PRIEST_DotA;
		elseif ( dot == 2 ) then
			return DotTracker_PRIEST_DotB;
		elseif ( dot == 3 ) then
			return DotTracker_PRIEST_DotC;
		end

	elseif ( DotTracker_Dots.class == "SHAMAN" ) then
		if ( dot == 1 ) then
			return DotTracker_SHAMAN_DotA;
		end

	elseif ( DotTracker_Dots.class == "WARLOCK" ) then
		if ( dot == 1 ) then
			return DotTracker_WARLOCK_DotA;
		elseif ( dot == 2 ) then
			text = string.format(DotTracker_WARLOCK_DotB.." / "..DotTracker_WARLOCK_DotBUA_short);
			return text;
		elseif ( dot == 3 ) then
			return DotTracker_WARLOCK_DotC;
		elseif ( dot == 4 ) then
			return DotTracker_WARLOCK_DotD;
		elseif ( dot == 5 ) then
			return DotTracker_WARLOCK_DotE;
		elseif ( dot == 6 ) then
			return DotTracker_WARLOCK_DotF;
		elseif ( dot == 7 ) then
			return DotTracker_WARLOCK_DotG;
		end

	elseif ( DotTracker_Dots.class == "WARRIOR" ) then
		if ( dot == 1 ) then
			return DotTracker_WARRIOR_DotA;
		elseif ( dot == 2 ) then
			return DotTracker_WARRIOR_DotB;
		elseif ( dot == 3 ) then
			return DotTracker_WARRIOR_DotC;
		elseif ( dot == 4 ) then
			return DotTracker_WARRIOR_DotD;
		elseif ( dot == 5 ) then
			return DotTracker_WARRIOR_DotE;
		end
	end

	return " ";
end


