function DotTracker_ChangeSpec()
	if ( DotTracker_Dots.spec == 1 ) then
		DotTracker_Options.widthType = DotTracker_SpecA.widthType;
		DotTracker_Options.text = DotTracker_SpecA.text;
		DotTracker_Options.minWidth = DotTracker_SpecA.minWidth;
		DotTracker_Options.reminderFadeUp = DotTracker_SpecA.reminderFadeUp;
		DotTracker_Options.showInVehicle = DotTracker_SpecA.showInVehicle;
		DotTracker_Options.stanceCheck = DotTracker_SpecA.stanceCheck;
		DotTracker_Options.showFrames = DotTracker_SpecA.showFrames;
		DotTracker_Options.reminderAlpha = DotTracker_SpecA.reminderAlpha;

		DotTracker_Setting.showDotA = DotTracker_SpecA.showDotA;
		DotTracker_Setting.showDotB = DotTracker_SpecA.showDotB;
		DotTracker_Setting.showDotC = DotTracker_SpecA.showDotC;
		DotTracker_Setting.showDotD = DotTracker_SpecA.showDotD;
		DotTracker_Setting.showDotE = DotTracker_SpecA.showDotE;
		DotTracker_Setting.showDotF = DotTracker_SpecA.showDotF;
		DotTracker_Setting.showDotG = DotTracker_SpecA.showDotG;

		DotTracker_Setting.combatOnly = DotTracker_SpecA.combatOnly;
		DotTracker_Setting.reminderDotA = DotTracker_SpecA.reminderDotA;
		DotTracker_Setting.reminderDotB = DotTracker_SpecA.reminderDotB;
		DotTracker_Setting.reminderDotC = DotTracker_SpecA.reminderDotC;
		DotTracker_Setting.reminderDotD = DotTracker_SpecA.reminderDotD;
		DotTracker_Setting.reminderDotE = DotTracker_SpecA.reminderDotE;
		DotTracker_Setting.reminderDotF = DotTracker_SpecA.reminderDotF;
		DotTracker_Setting.reminderDotG = DotTracker_SpecA.reminderDotG;

		DotTracker_Setting.minLevelDotA = DotTracker_SpecA.minLevelDotA;
		DotTracker_Setting.minLevelDotB = DotTracker_SpecA.minLevelDotB;
		DotTracker_Setting.minLevelDotC = DotTracker_SpecA.minLevelDotC;
		DotTracker_Setting.minLevelDotD = DotTracker_SpecA.minLevelDotD;
		DotTracker_Setting.minLevelDotE = DotTracker_SpecA.minLevelDotE;
		DotTracker_Setting.minLevelDotF = DotTracker_SpecA.minLevelDotF;
		DotTracker_Setting.minLevelDotG = DotTracker_SpecA.minLevelDotG;

		DotTracker_Setting.widthA = DotTracker_SpecA.widthA;
		DotTracker_Setting.widthB = DotTracker_SpecA.widthB;
		DotTracker_Setting.widthC = DotTracker_SpecA.widthC;
		DotTracker_Setting.widthD = DotTracker_SpecA.widthD;
		DotTracker_Setting.widthE = DotTracker_SpecA.widthE;
		DotTracker_Setting.widthF = DotTracker_SpecA.widthF;
		DotTracker_Setting.widthG = DotTracker_SpecA.widthG;

		DotTracker_Setting.showTextA = DotTracker_SpecA.showTextA;
		DotTracker_Setting.showTextB = DotTracker_SpecA.showTextB;
		DotTracker_Setting.showTextC = DotTracker_SpecA.showTextC;
		DotTracker_Setting.showTextD = DotTracker_SpecA.showTextD;
		DotTracker_Setting.showTextE = DotTracker_SpecA.showTextE;
		DotTracker_Setting.showTextF = DotTracker_SpecA.showTextF;
		DotTracker_Setting.showTextG = DotTracker_SpecA.showTextG;

	elseif ( DotTracker_Dots.spec == 2 ) then
		DotTracker_Options.widthType = DotTracker_SpecB.widthType;
		DotTracker_Options.text = DotTracker_SpecB.text;
		DotTracker_Options.minWidth = DotTracker_SpecB.minWidth;
		DotTracker_Options.reminderFadeUp = DotTracker_SpecB.reminderFadeUp;
		DotTracker_Options.showInVehicle = DotTracker_SpecB.showInVehicle;
		DotTracker_Options.stanceCheck = DotTracker_SpecB.stanceCheck;
		DotTracker_Options.showFrames = DotTracker_SpecB.showFrames;
		DotTracker_Options.reminderAlpha = DotTracker_SpecB.reminderAlpha;

		DotTracker_Setting.showDotA = DotTracker_SpecB.showDotA;
		DotTracker_Setting.showDotB = DotTracker_SpecB.showDotB;
		DotTracker_Setting.showDotC = DotTracker_SpecB.showDotC;
		DotTracker_Setting.showDotD = DotTracker_SpecB.showDotD;
		DotTracker_Setting.showDotE = DotTracker_SpecB.showDotE;
		DotTracker_Setting.showDotF = DotTracker_SpecB.showDotF;
		DotTracker_Setting.showDotG = DotTracker_SpecB.showDotG;

		DotTracker_Setting.combatOnly = DotTracker_SpecB.combatOnly;
		DotTracker_Setting.reminderDotA = DotTracker_SpecB.reminderDotA;
		DotTracker_Setting.reminderDotB = DotTracker_SpecB.reminderDotB;
		DotTracker_Setting.reminderDotC = DotTracker_SpecB.reminderDotC;
		DotTracker_Setting.reminderDotD = DotTracker_SpecB.reminderDotD;
		DotTracker_Setting.reminderDotE = DotTracker_SpecB.reminderDotE;
		DotTracker_Setting.reminderDotF = DotTracker_SpecB.reminderDotF;
		DotTracker_Setting.reminderDotG = DotTracker_SpecB.reminderDotG;

		DotTracker_Setting.minLevelDotA = DotTracker_SpecB.minLevelDotA;
		DotTracker_Setting.minLevelDotB = DotTracker_SpecB.minLevelDotB;
		DotTracker_Setting.minLevelDotC = DotTracker_SpecB.minLevelDotC;
		DotTracker_Setting.minLevelDotD = DotTracker_SpecB.minLevelDotD;
		DotTracker_Setting.minLevelDotE = DotTracker_SpecB.minLevelDotE;
		DotTracker_Setting.minLevelDotF = DotTracker_SpecB.minLevelDotF;
		DotTracker_Setting.minLevelDotG = DotTracker_SpecB.minLevelDotG;

		DotTracker_Setting.widthA = DotTracker_SpecB.widthA;
		DotTracker_Setting.widthB = DotTracker_SpecB.widthB;
		DotTracker_Setting.widthC = DotTracker_SpecB.widthC;
		DotTracker_Setting.widthD = DotTracker_SpecB.widthD;
		DotTracker_Setting.widthE = DotTracker_SpecB.widthE;
		DotTracker_Setting.widthF = DotTracker_SpecB.widthF;
		DotTracker_Setting.widthG = DotTracker_SpecB.widthG;

		DotTracker_Setting.showTextA = DotTracker_SpecB.showTextA;
		DotTracker_Setting.showTextB = DotTracker_SpecB.showTextB;
		DotTracker_Setting.showTextC = DotTracker_SpecB.showTextC;
		DotTracker_Setting.showTextD = DotTracker_SpecB.showTextD;
		DotTracker_Setting.showTextE = DotTracker_SpecB.showTextE;
		DotTracker_Setting.showTextF = DotTracker_SpecB.showTextF;
		DotTracker_Setting.showTextG = DotTracker_SpecB.showTextG;
	end
	DotTracker_Frame_Size();
end


function DotTracker_StoreSpec(spec)
	if ( spec == 1 ) then
		DotTracker_SpecA.widthType = DotTracker_Options.widthType;
		DotTracker_SpecA.text = DotTracker_Options.text;
		DotTracker_SpecA.minWidth = DotTracker_Options.minWidth;
		DotTracker_SpecA.reminderFadeUp = DotTracker_Options.reminderFadeUp;
		DotTracker_SpecA.showInVehicle = DotTracker_Options.showInVehicle;
		DotTracker_SpecA.stanceCheck = DotTracker_Options.stanceCheck;
		DotTracker_SpecA.showFrames = DotTracker_Options.showFrames;
		DotTracker_SpecA.reminderAlpha = DotTracker_Options.reminderAlpha;

		DotTracker_SpecA.showDotA = DotTracker_Setting.showDotA;
		DotTracker_SpecA.showDotB = DotTracker_Setting.showDotB;
		DotTracker_SpecA.showDotC = DotTracker_Setting.showDotC;
		DotTracker_SpecA.showDotD = DotTracker_Setting.showDotD;
		DotTracker_SpecA.showDotE = DotTracker_Setting.showDotE;
		DotTracker_SpecA.showDotF = DotTracker_Setting.showDotF;
		DotTracker_SpecA.showDotG = DotTracker_Setting.showDotG;

		DotTracker_SpecA.combatOnly = DotTracker_Setting.combatOnly;
		DotTracker_SpecA.reminderDotA = DotTracker_Setting.reminderDotA;
		DotTracker_SpecA.reminderDotB = DotTracker_Setting.reminderDotB;
		DotTracker_SpecA.reminderDotC = DotTracker_Setting.reminderDotC;
		DotTracker_SpecA.reminderDotD = DotTracker_Setting.reminderDotD;
		DotTracker_SpecA.reminderDotE = DotTracker_Setting.reminderDotE;
		DotTracker_SpecA.reminderDotF = DotTracker_Setting.reminderDotF;
		DotTracker_SpecA.reminderDotG = DotTracker_Setting.reminderDotG;

		DotTracker_SpecA.minLevelDotA = DotTracker_Setting.minLevelDotA;
		DotTracker_SpecA.minLevelDotB = DotTracker_Setting.minLevelDotB;
		DotTracker_SpecA.minLevelDotC = DotTracker_Setting.minLevelDotC;
		DotTracker_SpecA.minLevelDotD = DotTracker_Setting.minLevelDotD;
		DotTracker_SpecA.minLevelDotE = DotTracker_Setting.minLevelDotE;
		DotTracker_SpecA.minLevelDotF = DotTracker_Setting.minLevelDotF;
		DotTracker_SpecA.minLevelDotG = DotTracker_Setting.minLevelDotG;

		DotTracker_SpecA.widthA = DotTracker_Setting.widthA;
		DotTracker_SpecA.widthB = DotTracker_Setting.widthB;
		DotTracker_SpecA.widthC = DotTracker_Setting.widthC;
		DotTracker_SpecA.widthD = DotTracker_Setting.widthD;
		DotTracker_SpecA.widthE = DotTracker_Setting.widthE;
		DotTracker_SpecA.widthF = DotTracker_Setting.widthF;
		DotTracker_SpecA.widthG = DotTracker_Setting.widthG;

		DotTracker_SpecA.showTextA = DotTracker_Setting.showTextA;
		DotTracker_SpecA.showTextB = DotTracker_Setting.showTextB;
		DotTracker_SpecA.showTextC = DotTracker_Setting.showTextC;
		DotTracker_SpecA.showTextD = DotTracker_Setting.showTextD;
		DotTracker_SpecA.showTextE = DotTracker_Setting.showTextE;
		DotTracker_SpecA.showTextF = DotTracker_Setting.showTextF;
		DotTracker_SpecA.showTextG = DotTracker_Setting.showTextG;

	elseif ( spec == 2 ) then
		DotTracker_SpecB.widthType = DotTracker_Options.widthType;
		DotTracker_SpecB.text = DotTracker_Options.text;
		DotTracker_SpecB.minWidth = DotTracker_Options.minWidth;
		DotTracker_SpecB.reminderFadeUp = DotTracker_Options.reminderFadeUp;
		DotTracker_SpecB.showInVehicle = DotTracker_Options.showInVehicle;
		DotTracker_SpecB.stanceCheck = DotTracker_Options.stanceCheck;
		DotTracker_SpecB.showFrames = DotTracker_Options.showFrames;
		DotTracker_SpecB.reminderAlpha = DotTracker_Options.reminderAlpha;

		DotTracker_SpecB.showDotA = DotTracker_Setting.showDotA;
		DotTracker_SpecB.showDotB = DotTracker_Setting.showDotB;
		DotTracker_SpecB.showDotC = DotTracker_Setting.showDotC;
		DotTracker_SpecB.showDotD = DotTracker_Setting.showDotD;
		DotTracker_SpecB.showDotE = DotTracker_Setting.showDotE;
		DotTracker_SpecB.showDotF = DotTracker_Setting.showDotF;
		DotTracker_SpecB.showDotG = DotTracker_Setting.showDotG;

		DotTracker_SpecB.combatOnly = DotTracker_Setting.combatOnly;
		DotTracker_SpecB.reminderDotA = DotTracker_Setting.reminderDotA;
		DotTracker_SpecB.reminderDotB = DotTracker_Setting.reminderDotB;
		DotTracker_SpecB.reminderDotC = DotTracker_Setting.reminderDotC;
		DotTracker_SpecB.reminderDotD = DotTracker_Setting.reminderDotD;
		DotTracker_SpecB.reminderDotE = DotTracker_Setting.reminderDotE;
		DotTracker_SpecB.reminderDotF = DotTracker_Setting.reminderDotF;
		DotTracker_SpecB.reminderDotG = DotTracker_Setting.reminderDotG;

		DotTracker_SpecB.minLevelDotA = DotTracker_Setting.minLevelDotA;
		DotTracker_SpecB.minLevelDotB = DotTracker_Setting.minLevelDotB;
		DotTracker_SpecB.minLevelDotC = DotTracker_Setting.minLevelDotC;
		DotTracker_SpecB.minLevelDotD = DotTracker_Setting.minLevelDotD;
		DotTracker_SpecB.minLevelDotE = DotTracker_Setting.minLevelDotE;
		DotTracker_SpecB.minLevelDotF = DotTracker_Setting.minLevelDotF;
		DotTracker_SpecB.minLevelDotG = DotTracker_Setting.minLevelDotG;

		DotTracker_SpecB.widthA = DotTracker_Setting.widthA;
		DotTracker_SpecB.widthB = DotTracker_Setting.widthB;
		DotTracker_SpecB.widthC = DotTracker_Setting.widthC;
		DotTracker_SpecB.widthD = DotTracker_Setting.widthD;
		DotTracker_SpecB.widthE = DotTracker_Setting.widthE;
		DotTracker_SpecB.widthF = DotTracker_Setting.widthF;
		DotTracker_SpecB.widthG = DotTracker_Setting.widthG;

		DotTracker_SpecB.showTextA = DotTracker_Setting.showTextA;
		DotTracker_SpecB.showTextB = DotTracker_Setting.showTextB;
		DotTracker_SpecB.showTextC = DotTracker_Setting.showTextC;
		DotTracker_SpecB.showTextD = DotTracker_Setting.showTextD;
		DotTracker_SpecB.showTextE = DotTracker_Setting.showTextE;
		DotTracker_SpecB.showTextF = DotTracker_Setting.showTextF;
		DotTracker_SpecB.showTextG = DotTracker_Setting.showTextG;
	end
end