function DotTracker_New_Version()
	if ( DotTracker_Options.version == nil ) then
		DotTracker_Options.version = 0.1;
	end
	if ( DotTracker_Options.version < 1.67 ) then
		DotTracker_Options.text = true;
		DotTracker_Options.widthType = 0;
	end
	if ( DotTracker_Options.version < 1.70 ) then
		DotTracker_Options.minWidth = 50;
	end
	if ( DotTracker_Options.version < 1.71 ) then
		DotTracker_Setting.minLevelDotA = 0;
		DotTracker_Setting.minLevelDotB = 0;
		DotTracker_Setting.minLevelDotC = 0;
	end
	if ( DotTracker_Options.version < 1.79 ) then
		DotTracker_Options.reminderFadeUp = false;
	end
	if ( DotTracker_Options.version < 1.81 ) then
		DotTracker_Options.showInVehicle = false;
	end
	if ( DotTracker_Options.version < 1.83 ) then
		DotTracker_Options.stanceCheck = false;
		DotTracker_StoreSpec(1);
		DotTracker_StoreSpec(2);
	end
	if ( DotTracker_Options.version < 1.91 ) then
		DotTracker_SpecA.showDotD = false;
		DotTracker_SpecA.reminderDotD = 0;
		DotTracker_SpecA.minLevelDotD = 0;

		DotTracker_SpecB.showDotD = false;
		DotTracker_SpecB.reminderDotD = 0;
		DotTracker_SpecB.minLevelDotD = 0;
	end
	if ( DotTracker_Options.version < 1.92 ) then
		DotTracker_SpecA.showDotE = false;
		DotTracker_SpecA.reminderDotE = 0;
		DotTracker_SpecA.minLevelDotE = 0;

		DotTracker_SpecB.showDotE = false;
		DotTracker_SpecB.reminderDotE = 0;
		DotTracker_SpecB.minLevelDotE = 0;
	end
	if ( DotTracker_Options.version < 1.96 ) then
		DotTracker_SpecA.showDotF = false;
		DotTracker_SpecA.reminderDotF = 0;
		DotTracker_SpecA.minLevelDotF = 0;

		DotTracker_SpecB.showDotF = false;
		DotTracker_SpecB.reminderDotF = 0;
		DotTracker_SpecB.minLevelDotF = 0;

		DotTracker_SpecA.showDotG = false;
		DotTracker_SpecA.reminderDotG = 0;
		DotTracker_SpecA.minLevelDotG = 0;

		DotTracker_SpecB.showDotG = false;
		DotTracker_SpecB.reminderDotG = 0;
		DotTracker_SpecB.minLevelDotG = 0;
	end
	if ( DotTracker_Options.version < 2.03 ) then
		DotTracker_SpecA.showFrames = true;
		DotTracker_SpecB.showFrames = true;
		DotTracker_Options.showFrames = true;

		DotTracker_Setting.widthA = 50;
		DotTracker_Setting.widthB = 50;
		DotTracker_Setting.widthC = 50;
		DotTracker_Setting.widthD = 50;
		DotTracker_Setting.widthE = 50;
		DotTracker_Setting.widthF = 50;
		DotTracker_Setting.widthG = 50;

		DotTracker_SpecA.widthA = 50;
		DotTracker_SpecA.widthB = 50;
		DotTracker_SpecA.widthC = 50;
		DotTracker_SpecA.widthD = 50;
		DotTracker_SpecA.widthE = 50;
		DotTracker_SpecA.widthF = 50;
		DotTracker_SpecA.widthG = 50;

		DotTracker_SpecB.widthA = 50;
		DotTracker_SpecB.widthB = 50;
		DotTracker_SpecB.widthC = 50;
		DotTracker_SpecB.widthD = 50;
		DotTracker_SpecB.widthE = 50;
		DotTracker_SpecB.widthF = 50;
		DotTracker_SpecB.widthG = 50;
		
	end
	if ( DotTracker_Options.version < 2.09 ) then
		DotTracker_Options.reminderAlpha = 1;
		DotTracker_SpecA.reminderAlpha = 1;
		DotTracker_SpecB.reminderAlpha = 1;
	end
	if ( DotTracker_Options.version < 2.10 ) then
		DotTracker_Setting.showTextA = DotTracker_Options.text;
		DotTracker_Setting.showTextB = DotTracker_Options.text;
		DotTracker_Setting.showTextC = DotTracker_Options.text;
		DotTracker_Setting.showTextD = DotTracker_Options.text;
		DotTracker_Setting.showTextE = DotTracker_Options.text;
		DotTracker_Setting.showTextF = DotTracker_Options.text;
		DotTracker_Setting.showTextG = DotTracker_Options.text;

		DotTracker_SpecA.showTextA = DotTracker_SpecA.text;
		DotTracker_SpecA.showTextB = DotTracker_SpecA.text;
		DotTracker_SpecA.showTextC = DotTracker_SpecA.text;
		DotTracker_SpecA.showTextD = DotTracker_SpecA.text;
		DotTracker_SpecA.showTextE = DotTracker_SpecA.text;
		DotTracker_SpecA.showTextF = DotTracker_SpecA.text;
		DotTracker_SpecA.showTextG = DotTracker_SpecA.text;

		DotTracker_SpecB.showTextA = DotTracker_SpecB.text;
		DotTracker_SpecB.showTextB = DotTracker_SpecB.text;
		DotTracker_SpecB.showTextC = DotTracker_SpecB.text;
		DotTracker_SpecB.showTextD = DotTracker_SpecB.text;
		DotTracker_SpecB.showTextE = DotTracker_SpecB.text;
		DotTracker_SpecB.showTextF = DotTracker_SpecB.text;
		DotTracker_SpecB.showTextG = DotTracker_SpecB.text;
	end
	DotTracker_Options.version = DOTTRACKER_VERSION;
end


