function DotTracker_Options_Toggle()
	DotTracker_StoreSpec(DotTracker_Dots.spec);
end


function DotTracker_SetupSlider(self, text, myMin, myMax, step)
    getglobal(self:GetName().."Text") :SetText(text);
    getglobal(self:GetName().."Low") :SetText(myMin);
    getglobal(self:GetName().."High") :SetText(myMax);
    self:SetMinMaxValues(myMin, myMax);
    self:SetValueStep(step);
end


function DotTracker_Options_Init()
	DotTracker_WidthType_Menu_Logic();
	DoTracker_Option_EditBox_Update();
end


function DotTracker_WidthType_Menu_Logic()
	DotTracker_Frame_Size();
end


function DoTracker_Option_EditBox_Update()
	local textA, textB, textC, textD, textE, textF, textG;
	
	textA = string.format("Reminder: %ds", DotTracker_Setting.reminderDotA);
	textB = string.format("Reminder: %ds", DotTracker_Setting.reminderDotB);
	textC = string.format("Reminder: %ds", DotTracker_Setting.reminderDotC);
	textD = string.format("Reminder: %ds", DotTracker_Setting.reminderDotD);
	textE = string.format("Reminder: %ds", DotTracker_Setting.reminderDotE);
	textF = string.format("Reminder: %ds", DotTracker_Setting.reminderDotF);
	textG = string.format("Reminder: %ds", DotTracker_Setting.reminderDotG);

	if ( DotTracker_Setting.minLevelDotA == -1 ) then
		textA = "Min Lvl: Raid Boss";
	else
		textA = string.format("Min Lvl: %d", DotTracker_Setting.minLevelDotA);
	end

	if ( DotTracker_Setting.minLevelDotB == -1 ) then
		textB = "Min Lvl: Raid Boss";
	else
		textB = string.format("Min Lvl: %d", DotTracker_Setting.minLevelDotB);
	end

	if ( DotTracker_Setting.minLevelDotC == -1 ) then
		textC = "Min Lvl: Raid Boss";
	else
		textC = string.format("Min Lvl: %d", DotTracker_Setting.minLevelDotC);
	end

	if ( DotTracker_Setting.minLevelDotD == -1 ) then
		textD = "Min Lvl: Raid Boss";
	else
		textD = string.format("Min Lvl: %d", DotTracker_Setting.minLevelDotD);
	end

	if ( DotTracker_Setting.minLevelDotE == -1 ) then
		textE = "Min Lvl: Raid Boss";
	else
		textE = string.format("Min Lvl: %d", DotTracker_Setting.minLevelDotE);
	end

	if ( DotTracker_Setting.minLevelDotF == -1 ) then
		textF = "Min Lvl: Raid Boss";
	else
		textF = string.format("Min Lvl: %d", DotTracker_Setting.minLevelDotF);
	end

	if ( DotTracker_Setting.minLevelDotG == -1 ) then
		textG = "Min Lvl: Raid Boss";
	else
		textG = string.format("Min Lvl: %d", DotTracker_Setting.minLevelDotG);
	end
end


function DotTracker_Frame_Size()
	local textLengthA = 0;
	local textLengthB = 0;
	local textLengthC = 0;
	local textLengthD = 0;
	local textLengthE = 0;
	local textLengthF = 0;
	local textLengthG = 0;

	local frameWidthA = 0;
	local frameWidthB = 0;
	local frameWidthC = 0;
	local frameWidthD = 0;
	local frameWidthE = 0;
	local frameWidthF = 0;
	local frameWidthG = 0;

	if ( DotTracker_Options.showFrames == true ) then
		DotTracker_Dots.current_min_width = DOTTRACKER_MIN_WIDTH;
		DotTracker_Dots.current_min_height = DOTTRACKER_MIN_HEIGHT;
	else
		DotTracker_Dots.current_min_width = DOTTRACKER_NO_FRAME_WIDTH;
		DotTracker_Dots.current_min_height = DOTTRACKER_NO_FRAME_HEIGHT;
	end

	if ( DotTracker_Options.widthType == 0 ) then
		if ( DotTracker_Options.text == true ) then
			if ( DotTracker_Dots.class == "DEATHKNIGHT" ) then
				if ( DotTracker_Setting.reminderDotA == 0 ) then
					frameWidthA = 122;
				else
					frameWidthA = 160;
				end
				if ( DotTracker_Setting.reminderDotB == 0 ) then
					frameWidthB = 140;
				else
					frameWidthB = 170;
				end
			elseif ( DotTracker_Dots.class == "DRUID" ) then
				if ( DotTracker_Setting.reminderDotA == 0 ) then
					frameWidthA = 115;
				else
					frameWidthA = 148;
				end
				if ( DotTracker_Setting.reminderDotB == 0 ) then
					frameWidthB = 131;
				else
					frameWidthB = 160;
				end
				if ( DotTracker_Setting.reminderDotC == 0 ) then
					frameWidthC = 138;
				else
					frameWidthC = 174;
				end
				if ( DotTracker_Setting.reminderDotD == 0 ) then
					frameWidthD = 164;
				else
					frameWidthD = 199;
				end
				if ( DotTracker_Setting.reminderDotE == 0 ) then
					frameWidthE = 105;
				else
					frameWidthE = 140;
				end
				if ( DotTracker_Setting.reminderDotF == 0 ) then
					frameWidthF = 86;
				else
					frameWidthF = 123;
				end
				if ( DotTracker_Setting.reminderDotG == 0 ) then
					frameWidthG = 74;
				else
					frameWidthG = 111;
				end
			elseif ( DotTracker_Dots.class == "HUNTER" ) then
				if ( DotTracker_Setting.reminderDotA == 0 ) then
					frameWidthA = 90;
				else
					frameWidthA = 122;
				end
			elseif ( DotTracker_Dots.class == "MAGE" ) then
				if ( DotTracker_Setting.reminderDotA == 0 ) then
					frameWidthA = 133;
				else
					frameWidthA = 171;
				end
			elseif ( DotTracker_Dots.class == "PALADIN" ) then
				if ( DotTracker_Setting.reminderDotA == 0 ) then
					frameWidthA = 122;
				else
					frameWidthA = 158;
				end
			elseif ( DotTracker_Dots.class == "PRIEST" ) then
				if ( DotTracker_Setting.reminderDotA == 0 ) then
					frameWidthA = 166;
				else
					frameWidthA = 198;
				end
				if ( DotTracker_Setting.reminderDotB == 0 ) then
					frameWidthB = 152;
				else
					frameWidthB = 186;
				end
				if ( DotTracker_Setting.reminderDotC == 0 ) then
					frameWidthC = 175;
				else
					frameWidthC = 210;
				end
			elseif ( DotTracker_Dots.class == "SHAMAN" ) then
				if ( DotTracker_Setting.reminderDotA == 0 ) then
					frameWidthA = 134;
				else
					frameWidthA = 168;
				end
			elseif ( DotTracker_Dots.class == "WARLOCK" ) then
				if ( DotTracker_Setting.reminderDotA == 0 ) then
					frameWidthA = 124;
				else
					frameWidthA = 160;
				end
				if ( DotTracker_Setting.reminderDotB == 0 ) then
					frameWidthB = 116;
				else
					frameWidthB = 150;
				end
				if ( DotTracker_Setting.reminderDotC == 0 ) then
					frameWidthC = 92;
				else
					frameWidthC = 134;
				end
				if ( DotTracker_Setting.reminderDotD == 0 ) then
					frameWidthD = 158;
				else
					frameWidthD = 209;
				end
				if ( DotTracker_Setting.reminderDotE == 0 ) then
					frameWidthE = 84;
				else
					frameWidthE = 119;
				end
				if ( DotTracker_Setting.reminderDotF == 0 ) then
					frameWidthF = 91;
				else
					frameWidthF = 130;
				end
				if ( DotTracker_Setting.reminderDotG == 0 ) then
					frameWidthG = 172;
				else
					frameWidthG = 209;
				end
			elseif ( DotTracker_Dots.class == "WARRIOR" ) then
				if ( DotTracker_Setting.reminderDotA == 0 ) then
					frameWidthA = 90;
				else
					frameWidthA = 122;
				end
				if ( DotTracker_Setting.reminderDotB == 0 ) then
					frameWidthB = 110;
				else
					frameWidthB = 145;
				end
				if ( DotTracker_Setting.reminderDotC == 0 ) then
					frameWidthC = 120;
				else
					frameWidthC = 156;
				end
				if ( DotTracker_Setting.reminderDotD == 0 ) then
					frameWidthD = 137;
				else
					frameWidthD = 171;
				end
				if ( DotTracker_Setting.reminderDotE == 0 ) then
					frameWidthE = 179;
				else
					frameWidthE = 212;
				end
			end
		else
			frameWidthA = DotTracker_Dots.current_min_width;
			frameWidthB = DotTracker_Dots.current_min_width;
			frameWidthC = DotTracker_Dots.current_min_width;
			frameWidthD = DotTracker_Dots.current_min_width;
			frameWidthE = DotTracker_Dots.current_min_width;
			frameWidthF = DotTracker_Dots.current_min_width;
			frameWidthG = DotTracker_Dots.current_min_width;
		end
	elseif ( DotTracker_Options.widthType == 2 ) then
		if ( DotTracker_Options.text == true ) then
			if ( DotTracker_Setting.reminderDotA > 0 ) then
				textLengthA = 7;
			end
			if ( DotTracker_Setting.reminderDotB > 0 ) then
				textLengthB = 7;
			end
			if ( DotTracker_Setting.reminderDotC > 0 ) then
				textLengthC = 7;
			end
			if ( DotTracker_Dots.class == "DEATHKNIGHT" ) then
				textLengthA = textLengthA + string.len(DotTracker_DEATHKNIGHT_DotA);
				textLengthB = textLengthB + string.len(DotTracker_DEATHKNIGHT_DotB);
			elseif ( DotTracker_Dots.class == "DRUID" ) then
				textLengthA = textLengthA + string.len(DotTracker_DRUID_DotA);
				textLengthB = textLengthB + string.len(DotTracker_DRUID_DotB);
				textLengthC = textLengthC + string.len(DotTracker_DRUID_DotC);
				textLengthD = textLengthD + string.len(DotTracker_DRUID_DotD);
				textLengthE = textLengthE + string.len(DotTracker_DRUID_DotE);
				textLengthF = textLengthF + string.len(DotTracker_DRUID_DotF);
				textLengthG = textLengthG + string.len(DotTracker_DRUID_DotG);
			elseif ( DotTracker_Dots.class == "HUNTER" ) then
				textLengthA = textLengthA + string.len(DotTracker_HUNTER_DotA);
			elseif ( DotTracker_Dots.class == "MAGE" ) then
				textLengthA = textLengthA + string.len(DotTracker_MAGE_DotA);
			elseif ( DotTracker_Dots.class == "PALADIN" ) then
				textLengthA = textLengthA + string.len(DotTracker_PALADIN_DotA);
			elseif ( DotTracker_Dots.class == "PRIEST" ) then
				textLengthA = textLengthA + string.len(DotTracker_PRIEST_DotA);
				textLengthB = textLengthB + string.len(DotTracker_PRIEST_DotB);
				textLengthC = textLengthC + string.len(DotTracker_PRIEST_DotC);
			elseif ( DotTracker_Dots.class == "SHAMAN" ) then
				textLengthA = textLengthA + string.len(DotTracker_SHAMAN_DotA);
			elseif ( DotTracker_Dots.class == "WARLOCK" ) then
				textLengthA = textLengthA + string.len(DotTracker_WARLOCK_DotA);
				textLengthB = textLengthB + string.len(DotTracker_WARLOCK_DotB);
				textLengthC = textLengthC + string.len(DotTracker_WARLOCK_DotC);
				textLengthD = textLengthD + string.len(DotTracker_WARLOCK_DotD);
				textLengthE = textLengthE + string.len(DotTracker_WARLOCK_DotE);
				textLengthF = textLengthF + string.len(DotTracker_WARLOCK_DotF);
				textLengthG = textLengthG + string.len(DotTracker_WARLOCK_DotG);
			elseif ( DotTracker_Dots.class == "WARRIOR" ) then
				textLengthA = textLengthA + string.len(DotTracker_WARRIOR_DotA);
				textLengthB = textLengthB + string.len(DotTracker_WARRIOR_DotB);
				textLengthC = textLengthC + string.len(DotTracker_WARRIOR_DotC);
				textLengthD = textLengthD + string.len(DotTracker_WARRIOR_DotD);
				textLengthE = textLengthE + string.len(DotTracker_WARRIOR_DotE);
			end
			frameWidthA = DotTracker_String_To_Frame(textLengthA);
			frameWidthB = DotTracker_String_To_Frame(textLengthB);
			frameWidthC = DotTracker_String_To_Frame(textLengthC);
			frameWidthD = DotTracker_String_To_Frame(textLengthD);
			frameWidthE = DotTracker_String_To_Frame(textLengthE);
			frameWidthF = DotTracker_String_To_Frame(textLengthF);
			frameWidthG = DotTracker_String_To_Frame(textLengthG);
		else
			frameWidthA = DotTracker_Dots.current_min_width;
			frameWidthB = DotTracker_Dots.current_min_width;
			frameWidthC = DotTracker_Dots.current_min_width;
			frameWidthD = DotTracker_Dots.current_min_width;
			frameWidthE = DotTracker_Dots.current_min_width;
			frameWidthF = DotTracker_Dots.current_min_width;
			frameWidthG = DotTracker_Dots.current_min_width;
		end
	elseif ( DotTracker_Options.widthType == 3 ) then
		if ( DotTracker_Dots.class == "DEATHKNIGHT" ) then
			DotTrack_SetConstantFrameWidth(170);
		elseif ( DotTracker_Dots.class == "DRUID" ) then
			DotTrack_SetConstantFrameWidth(199);
		elseif ( DotTracker_Dots.class == "HUNTER" ) then
			DotTrack_SetConstantFrameWidth(122);
		elseif ( DotTracker_Dots.class == "MAGE" ) then
			DotTrack_SetConstantFrameWidth(171);
		elseif ( DotTracker_Dots.class == "PALADIN" ) then
			DotTrack_SetConstantFrameWidth(158);
		elseif ( DotTracker_Dots.class == "PRIEST" ) then
			DotTrack_SetConstantFrameWidth(210);
		elseif ( DotTracker_Dots.class == "SHAMAN" ) then
			DotTrack_SetConstantFrameWidth(168);
		elseif ( DotTracker_Dots.class == "WARLOCK" ) then
			DotTrack_SetConstantFrameWidth(209);
		elseif ( DotTracker_Dots.class == "WARRIOR" ) then
			DotTrack_SetConstantFrameWidth(212);
		end
	else
		frameWidthA = DotTracker_Setting.widthA;
		frameWidthB = DotTracker_Setting.widthB;
		frameWidthC = DotTracker_Setting.widthC;
		frameWidthD = DotTracker_Setting.widthD;
		frameWidthE = DotTracker_Setting.widthE;
		frameWidthF = DotTracker_Setting.widthF;
		frameWidthG = DotTracker_Setting.widthG;
		
	end

	if ( DotTracker_Options.minWidth > frameWidthA ) then
		frameWidthA = DotTracker_Options.minWidth;
	end
	if ( DotTracker_Options.minWidth > frameWidthB ) then
		frameWidthB = DotTracker_Options.minWidth;
	end
	if ( DotTracker_Options.minWidth > frameWidthC ) then
		frameWidthC = DotTracker_Options.minWidth;
	end
	if ( DotTracker_Options.minWidth > frameWidthD ) then
		frameWidthD = DotTracker_Options.minWidth;
	end
	if ( DotTracker_Options.minWidth > frameWidthE ) then
		frameWidthE = DotTracker_Options.minWidth;
	end
	if ( DotTracker_Options.minWidth > frameWidthF ) then
		frameWidthF = DotTracker_Options.minWidth;
	end
	if ( DotTracker_Options.minWidth > frameWidthG ) then
		frameWidthG = DotTracker_Options.minWidth;
	end

	DotTracker_DotA_Frame:SetWidth(frameWidthA);
	DotTracker_DotB_Frame:SetWidth(frameWidthB);
	DotTracker_DotC_Frame:SetWidth(frameWidthC);
	DotTracker_DotD_Frame:SetWidth(frameWidthD);
	DotTracker_DotE_Frame:SetWidth(frameWidthE);
	DotTracker_DotF_Frame:SetWidth(frameWidthF);
	DotTracker_DotG_Frame:SetWidth(frameWidthG);

	if ( DotTracker_Options.widthType == 1 ) then
		DotTrack_SetConstantFrameWidth(DotTracker_Dots.current_min_width);
	end

	DotTracker_DotA_Frame:SetHeight(DotTracker_Dots.current_min_height);
	DotTracker_DotB_Frame:SetHeight(DotTracker_Dots.current_min_height);
	DotTracker_DotC_Frame:SetHeight(DotTracker_Dots.current_min_height);
	DotTracker_DotD_Frame:SetHeight(DotTracker_Dots.current_min_height);
	DotTracker_DotE_Frame:SetHeight(DotTracker_Dots.current_min_height);
	DotTracker_DotF_Frame:SetHeight(DotTracker_Dots.current_min_height);
	DotTracker_DotG_Frame:SetHeight(DotTracker_Dots.current_min_height);
end


function DotTracker_String_To_Frame(stringLength)
	local frameWidth = 0;
		
	frameWidth = 50 + (stringLength * 8);

	return frameWidth;
end


function DotTracker_Toggle_Show_Frame()
	if ( DotTracker_Options.showFrames == true ) then
		DotTracker_Options.showFrames = false;
	else
		DotTracker_Options.showFrames = true;
	end
	DotTracker_Frame_Size();
end


function DotTrack_SetConstantFrameWidth(width)
	DotTracker_DotA_Frame:SetWidth(width);
	DotTracker_DotB_Frame:SetWidth(width);
	DotTracker_DotC_Frame:SetWidth(width);
	DotTracker_DotD_Frame:SetWidth(width);
	DotTracker_DotE_Frame:SetWidth(width);
	DotTracker_DotF_Frame:SetWidth(width);
	DotTracker_DotG_Frame:SetWidth(width);
end


function DotTracker_SetAllText(show)
	DotTracker_Setting.showTextA = show;
	DotTracker_Setting.showTextB = show;
	DotTracker_Setting.showTextC = show;
	DotTracker_Setting.showTextD = show;
	DotTracker_Setting.showTextE = show;
	DotTracker_Setting.showTextF = show;
	DotTracker_Setting.showTextG = show;
	DotTracker_StoreSpec(DotTracker_Dots.spec);
end